package io.zipcoder;

import java.util.Stack;

public class ParenChecker {
    Stack<Character> stack;
    char[] charArr;
    final char openParan = '(';
    final char openCurly = '{';
    final char openBrack = '[';
    final char openCompa = '<';
    final char openDQuot = '"';
    final char openSQuot = '\'';

    final char closeParan = ')';
    final char closeCurly = '}';
    final char closeBrack = ']';
    final char closeCompa = '>';
    final char closeDQuot = '"';
    final char closeSQuot = '\'';

    ParenChecker() {
        stack = new Stack<Character>();
    }

    public boolean isBalancedParens(String s) {
        for (char c : charArr = s.toCharArray()) {
            if (isOpenOrClose(c)) {
                if (isOpening(c)) {
                    if (!stack.empty() && isQuoteMatch(c)){
                        stack.pop();
                    } else {
                        stack.push(c);
                    }
                } else if (stack.empty()) {
                    return false;
                } else if (isClosing(c)) {
                    if (isMatch(c)) {
                        stack.pop();
                    } else {
                        return false;
                    }
                }
            }
        }
        return stack.empty();
    }

    public boolean isOpening(char c){
        boolean returnValue = false;
        if (c == openParan || c == openBrack || c == openCurly || c == openCompa || c == openDQuot || c == openSQuot){
            returnValue = true;
        }
        return returnValue;
    }

    public boolean isClosing(char c){
        boolean returnValue = false;
        if (c == closeParan || c == closeCurly || c == closeBrack || c == closeCompa || c == closeDQuot || c == closeSQuot){
            returnValue = true;
        }
        return returnValue;
    }

    public boolean isMatch(char c){
        boolean returnValue;
        if (
        (c == closeParan && stack.peek() == openParan) ||
        (c == closeBrack && stack.peek() == openBrack) ||
        (c == closeCurly && stack.peek() == openCurly) ||
        (c == closeDQuot && stack.peek() == openDQuot) ||
        (c == closeSQuot && stack.peek() == openSQuot) ||
        (c == closeCompa && stack.peek() == openCompa) ){
            returnValue = true;
        } else {
            returnValue = false;
        }
        return returnValue;
    }

    public boolean isQuoteMatch(char c){
        boolean returnValue;
        if ((c == closeDQuot && stack.peek() == openDQuot) || (c == closeSQuot && stack.peek() == openSQuot) ){
            returnValue = true;
        } else {
            returnValue = false;
        }
        return returnValue;
    }


    public boolean isOpenOrClose(char c) {
        if (c == openParan || c == openBrack || c == openCurly || c == openCompa || c == openDQuot || c == openSQuot ||
            c == closeParan || c == closeCurly || c == closeBrack || c == closeCompa || c == closeDQuot || c == closeSQuot) {
            return true;
        } else {
            return false;
        }
    }


}
