package io.zipcoder;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.*;
import java.util.stream.*;

public class WC {
    private Iterator<String> si;
    HashMap<String, Integer> wordCount = new HashMap<String, Integer>();

    public WC(String fileName) {
        try {
            si = new Scanner(new FileReader(fileName));
            ((Scanner) si).useDelimiter("[\\p{Punct}\\s]");
        } catch (FileNotFoundException e) {
            System.out.println(fileName + " Does Not Exist");
            System.exit(-1);
        }
        makeList();
    }


    public void makeList(){
        while (si.hasNext()){
            String word = si.next().toLowerCase();
            Integer count = wordCount.get(word);
            if (count != null){
                wordCount.put(word, count + 1);
            } else {
                wordCount.put(word, 1);
            }
        }
    }

    public WC(Iterator<String> si) {
        this.si = si;
    }

    public void orderList() {
        Map<String, Integer> sortedWordCount = new TreeMap<String, Integer>(wordCount);
        for(Map.Entry<String, Integer> entry : sortedWordCount.entrySet()){
            System.out.println(entry.getKey() + ": " + entry.getValue() + "\n");
        }

    }
}
//get file.txt
//go through each line and
// if new words
//add word to array, count 1
//if old word
//count++ to old word in array

//sort array descending
//collections .stream(), treemap<>;