package io.zipcoder;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class ParenCheckerTest {
    ParenChecker parenChecker = new ParenChecker();
    //Stack stack = new Stack();

    @Before
    public void setup(){

    }

    @Test
    public void isOpenOrCloseTest(){
        //GIVEN
        char c = '}';

        boolean expected = true;
        //WHEN
        boolean actual = parenChecker.isOpenOrClose(c);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void isOpenOrCloseTestFalse(){
        //GIVEN
        char c = 'g';

        boolean expected = false;
        //WHEN
        boolean actual = parenChecker.isOpenOrClose(c);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void isOpeningTest(){
        //GIVEN
        char c = '(';

        boolean expected = true;
        //WHEN
        boolean actual = parenChecker.isOpening(c);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void isClosingTest(){
        //GIVEN
        char c = '}';

        boolean expected = true;
        //WHEN
        boolean actual = parenChecker.isClosing(c);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void isClosingTestFalse(){
        //GIVEN
        char c = '/';

        boolean expected = false;
        //WHEN
        boolean actual = parenChecker.isClosing(c);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void isMatch(){
        //GIVEN
        char c = ')';
        parenChecker.stack.push('(');

        boolean expected = true;
        //WHEN
        boolean actual = parenChecker.isMatch(c);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void isMatchFalse(){
        //GIVEN
        char c = '}';
        parenChecker.stack.push('(');

        boolean expected = false;
        //WHEN
        boolean actual = parenChecker.isMatch(c);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void paranChecker(){
        //GIVEN
        String word = "<>(word)";

        boolean expected = true;
        //WHEN
        boolean actual = parenChecker.isBalancedParens(word);
        //THEN
        Assert.assertEquals(expected, actual);
    }
    @Test
    public void paranCheckerFalse(){
        //GIVEN
        String word = "(word))";

        boolean expected = false;
        //WHEN
        boolean actual = parenChecker.isBalancedParens(word);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void paranCheckerCurly(){
        //GIVEN
        String word = "\"\"({word})";

        boolean expected = true;
        //WHEN
        boolean actual = parenChecker.isBalancedParens(word);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void paranCheckerCurlyFalse(){
        //GIVEN
        String word = "{({word})";

        boolean expected = false;
        //WHEN
        boolean actual = parenChecker.isBalancedParens(word);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void checkQuotesTestFalse(){
        //GIVEN
        String word = "\'{({word})}";

        boolean expected = false;
        //WHEN
        boolean actual = parenChecker.isBalancedParens(word);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void checkQuotesTest(){
        //GIVEN
        String word = "\"\'{({word})}\'\"";

        boolean expected = true;
        //WHEN
        boolean actual = parenChecker.isBalancedParens(word);
        //THEN
        Assert.assertEquals(expected, actual);
    }

}